// generated from rosidl_generator_c/resource/idl__description.c.em
// with input from autoware_control_msgs:msg/Lateral.idl
// generated code does not contain a copyright notice

#include "autoware_control_msgs/msg/detail/lateral__functions.h"

ROSIDL_GENERATOR_C_PUBLIC_autoware_control_msgs
const rosidl_type_hash_t *
autoware_control_msgs__msg__Lateral__get_type_hash(
  const rosidl_message_type_support_t * type_support)
{
  (void)type_support;
  static rosidl_type_hash_t hash = {1, {
      0x94, 0xd3, 0x96, 0x34, 0x04, 0x1a, 0x92, 0xdb,
      0x4e, 0x46, 0x0d, 0xae, 0x93, 0xde, 0xf5, 0x64,
      0xfb, 0xeb, 0x89, 0x14, 0x2e, 0x9c, 0x64, 0xf9,
      0xc2, 0xed, 0x54, 0x0a, 0x18, 0x29, 0x35, 0xa1,
    }};
  return &hash;
}

#include <assert.h>
#include <string.h>

// Include directives for referenced types
#include "builtin_interfaces/msg/detail/time__functions.h"

// Hashes for external referenced types
#ifndef NDEBUG
static const rosidl_type_hash_t builtin_interfaces__msg__Time__EXPECTED_HASH = {1, {
    0xb1, 0x06, 0x23, 0x5e, 0x25, 0xa4, 0xc5, 0xed,
    0x35, 0x09, 0x8a, 0xa0, 0xa6, 0x1a, 0x3e, 0xe9,
    0xc9, 0xb1, 0x8d, 0x19, 0x7f, 0x39, 0x8b, 0x0e,
    0x42, 0x06, 0xce, 0xa9, 0xac, 0xf9, 0xc1, 0x97,
  }};
#endif

static char autoware_control_msgs__msg__Lateral__TYPE_NAME[] = "autoware_control_msgs/msg/Lateral";
static char builtin_interfaces__msg__Time__TYPE_NAME[] = "builtin_interfaces/msg/Time";

// Define type names, field names, and default values
static char autoware_control_msgs__msg__Lateral__FIELD_NAME__stamp[] = "stamp";
static char autoware_control_msgs__msg__Lateral__FIELD_NAME__control_time[] = "control_time";
static char autoware_control_msgs__msg__Lateral__FIELD_NAME__steering_tire_angle[] = "steering_tire_angle";
static char autoware_control_msgs__msg__Lateral__FIELD_NAME__steering_tire_rotation_rate[] = "steering_tire_rotation_rate";
static char autoware_control_msgs__msg__Lateral__FIELD_NAME__is_defined_steering_tire_rotation_rate[] = "is_defined_steering_tire_rotation_rate";

static rosidl_runtime_c__type_description__Field autoware_control_msgs__msg__Lateral__FIELDS[] = {
  {
    {autoware_control_msgs__msg__Lateral__FIELD_NAME__stamp, 5, 5},
    {
      rosidl_runtime_c__type_description__FieldType__FIELD_TYPE_NESTED_TYPE,
      0,
      0,
      {builtin_interfaces__msg__Time__TYPE_NAME, 27, 27},
    },
    {NULL, 0, 0},
  },
  {
    {autoware_control_msgs__msg__Lateral__FIELD_NAME__control_time, 12, 12},
    {
      rosidl_runtime_c__type_description__FieldType__FIELD_TYPE_NESTED_TYPE,
      0,
      0,
      {builtin_interfaces__msg__Time__TYPE_NAME, 27, 27},
    },
    {NULL, 0, 0},
  },
  {
    {autoware_control_msgs__msg__Lateral__FIELD_NAME__steering_tire_angle, 19, 19},
    {
      rosidl_runtime_c__type_description__FieldType__FIELD_TYPE_FLOAT,
      0,
      0,
      {NULL, 0, 0},
    },
    {NULL, 0, 0},
  },
  {
    {autoware_control_msgs__msg__Lateral__FIELD_NAME__steering_tire_rotation_rate, 27, 27},
    {
      rosidl_runtime_c__type_description__FieldType__FIELD_TYPE_FLOAT,
      0,
      0,
      {NULL, 0, 0},
    },
    {NULL, 0, 0},
  },
  {
    {autoware_control_msgs__msg__Lateral__FIELD_NAME__is_defined_steering_tire_rotation_rate, 38, 38},
    {
      rosidl_runtime_c__type_description__FieldType__FIELD_TYPE_BOOLEAN,
      0,
      0,
      {NULL, 0, 0},
    },
    {NULL, 0, 0},
  },
};

static rosidl_runtime_c__type_description__IndividualTypeDescription autoware_control_msgs__msg__Lateral__REFERENCED_TYPE_DESCRIPTIONS[] = {
  {
    {builtin_interfaces__msg__Time__TYPE_NAME, 27, 27},
    {NULL, 0, 0},
  },
};

const rosidl_runtime_c__type_description__TypeDescription *
autoware_control_msgs__msg__Lateral__get_type_description(
  const rosidl_message_type_support_t * type_support)
{
  (void)type_support;
  static bool constructed = false;
  static const rosidl_runtime_c__type_description__TypeDescription description = {
    {
      {autoware_control_msgs__msg__Lateral__TYPE_NAME, 33, 33},
      {autoware_control_msgs__msg__Lateral__FIELDS, 5, 5},
    },
    {autoware_control_msgs__msg__Lateral__REFERENCED_TYPE_DESCRIPTIONS, 1, 1},
  };
  if (!constructed) {
    assert(0 == memcmp(&builtin_interfaces__msg__Time__EXPECTED_HASH, builtin_interfaces__msg__Time__get_type_hash(NULL), sizeof(rosidl_type_hash_t)));
    description.referenced_type_descriptions.data[0].fields = builtin_interfaces__msg__Time__get_type_description(NULL)->type_description.fields;
    constructed = true;
  }
  return &description;
}

static char toplevel_type_raw_source[] =
  "# Lateral control message for Ackermann-style platforms\n"
  "#\n"
  "# Note regarding tires: If the platform has multiple steering tires, the commands\n"
  "# given here are for a virtual tire at the average lateral position of the steering tires.\n"
  "#\n"
  "# Look up Ackermann Bicycle Model for more details\n"
  "#\n"
  "# Positive values represents left inclination (if forward)\n"
  "# Negative values represents right inclination (if forward)\n"
  "\n"
  "# Time this message was created\n"
  "builtin_interfaces/Time stamp\n"
  "\n"
  "# Time this configuration state is expected to be achieved in (optional)\n"
  "builtin_interfaces/Time control_time\n"
  "\n"
  "# Desired angle of the steering tire in rad (radians)\n"
  "float32 steering_tire_angle\n"
  "\n"
  "# Desired rate of change of the steering tire angle in rad/s\n"
  "float32 steering_tire_rotation_rate\n"
  "\n"
  "# Controller has filled in the steering_tire_rotation_rate value\n"
  "bool is_defined_steering_tire_rotation_rate";

static char msg_encoding[] = "msg";

// Define all individual source functions

const rosidl_runtime_c__type_description__TypeSource *
autoware_control_msgs__msg__Lateral__get_individual_type_description_source(
  const rosidl_message_type_support_t * type_support)
{
  (void)type_support;
  static const rosidl_runtime_c__type_description__TypeSource source = {
    {autoware_control_msgs__msg__Lateral__TYPE_NAME, 33, 33},
    {msg_encoding, 3, 3},
    {toplevel_type_raw_source, 870, 870},
  };
  return &source;
}

const rosidl_runtime_c__type_description__TypeSource__Sequence *
autoware_control_msgs__msg__Lateral__get_type_description_sources(
  const rosidl_message_type_support_t * type_support)
{
  (void)type_support;
  static rosidl_runtime_c__type_description__TypeSource sources[2];
  static const rosidl_runtime_c__type_description__TypeSource__Sequence source_sequence = {sources, 2, 2};
  static bool constructed = false;
  if (!constructed) {
    sources[0] = *autoware_control_msgs__msg__Lateral__get_individual_type_description_source(NULL),
    sources[1] = *builtin_interfaces__msg__Time__get_individual_type_description_source(NULL);
    constructed = true;
  }
  return &source_sequence;
}
